/******************************************************************************
  * @Example IMMC
  * @author  ӦÿŶ
  * @version V1.6.0
  * @date    2023/12/18
  * @brief   EPPROMдݣȡͨڴӡ
  *          
  ******************************************************************************
  * @attention	Ϊ96001λֹͣλżУ
  *							
  *
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  *
  *****************************************************************************/
	
#include "PT32Y003x.h"


void Software_Delay(void)//ʱ
{
	u8 i, j,x;
	for(i=0; i<200; i++)
		for(j=0; j<200; j++)
			for(x=0; x<20; x++);
}

/**
* @brief UARTĸ
* @param 
* @retval 
*/
void UART_GPIO_Config(void)
{
	/* UARTܽŵĸù */
	GPIO_DigitalRemapConfig(AFIOD, GPIO_Pin_5, AFIO_AF_0,ENABLE);	//PD5 TX0
	GPIO_DigitalRemapConfig(AFIOD, GPIO_Pin_6, AFIO_AF_0,ENABLE);	//PD6 RX0
}

/**
* @brief UARTĹģʽ
* @param 
* @retval 
*/
void UART_Mode_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;

	/*ʼUART0*/
	UART_InitStruct.UART_BaudRate = 9600;
	UART_InitStruct.UART_WordLengthAndParity = UART_WordLengthAndParity_8D;
	UART_InitStruct.UART_StopBitLength = UART_StopBitLength_1;
	UART_InitStruct.UART_ParityMode = UART_ParityMode_Even;
	UART_InitStruct.UART_Receiver=UART_Receiver_Enable;
	UART_InitStruct.UART_LoopbackMode=UART_LoopbackMode_Disable;
	UART_Init(UART0, &UART_InitStruct);

	/*UART0շ*/
	UART_Cmd(UART0, ENABLE);
}

/**
* @brief UART
* @param 
* @retval 
*/
void UART_Driver(void)
{
	UART_GPIO_Config();
	UART_Mode_Config();
}

void ADC_Mode_Config(void)
{
	ADC_InitTypeDef  ADC_InitStruct;
	ADC_StructInit(&ADC_InitStruct);
	ADC_InitStruct.ADC_Prescaler = 64;						 	
	ADC_InitStruct.ADC_Mode = ADC_Mode_Single;						//תģʽ
	ADC_InitStruct.ADC_TriggerSource = ADC_TriggerSource_Software;
	ADC_InitStruct.ADC_TimerTriggerSource=ADC_TimerTriggerSource_TIM1ADC;						//ʱԴѡTIM0¼
	ADC_InitStruct.ADC_Align = ADC_Align_Right;					//Ҷ
	ADC_InitStruct.ADC_Channel=ADC_Channel_12;						
	ADC_InitStruct.ADC_ReferencePositive= ADC_ReferencePositive_VDD;	//ѡVDDAΪ˲οƽ
	ADC_InitStruct.ADC_BGVoltage=ADC_BGVoltage_BG1v0;
	ADC_Init(ADC, &ADC_InitStruct);
}

void IMMC_WaitConfig(u8 wait_state)
{
	IMMC->CR= ((IMMC_Key_MainCode) | (wait_state << 4)) ;
}

s32 Tx_Index = 0;
float volatge = 0;//VDDѹ
int i=0;
u8 wait_value=10;//ҪдIMMCȴֵ,ûʵ޸

int main (void)
{
	Software_Delay();
	UART_Driver();
	ADC_Mode_Config();
	printf("IMMCȴù\r\n");
	ADC_ChannelConfig(ADC,ADC_Channel_12);//ѡͨ12оƬڲڲοѹ,ֵBGSλ
	ADC_Cmd(ADC, ENABLE);		//ADC蹦
  while(!ADC_GetFlagStatus(ADC, ADC_FLAG_RDY));	//ȴADC
  
	for(i=0;i<10;i++)
	{		
		ADC_StartOfConversion(ADC);	//ת
		while(!ADC_GetFlagStatus(ADC, ADC_FLAG_EOC));		//ȴADCת
		Tx_Index += (s16)ADC_GetConversionValue(ADC);	//ȡ
	}
	Tx_Index/=10;
	volatge=((float)1.0*8192/Tx_Index);
	
	printf("ǰѹVDD:%.2f\r\n",volatge);
	if(volatge<2.4)
	{
		printf("VDDѹͣ޷IMMCõȴڲ\r\n");
		while(1);
	}
	else
	{
		printf("ִIMMCõȴڲ\r\n");
		IMMC_WaitConfig(wait_value);
		printf("ִв\r\n");
	}
	while(1);
}
	
#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %ld\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif
