/**
  ******************************************************************************
  * @file    system_PT32Y003x.c
  * @author  ӦÿŶ
  * @version V1.6.0
  * @date    2023/12/18
  * @brief   
  ******************************************************************************
  * @attention
  *
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣 
  * ̼/ͻʹаıϢκ,
  * Pai-ICκֱӣ ӻ̷𺦸
  * 
  * (C) ȨPai-IC Microelectronics  
  ******************************************************************************
  */


/* Includes ------------------------------------------------------------------*/
#include "PT32Y003x.h"

/**
  * @}
  */
void Wait_ClockReady(void)
{
	u8 i,j;
	for(i=0; i<100; i++)
		for(j=0; j<48; j++);
}



//<<< Use Configuration Wizard in Context Menu >>>
/*--------------------- Clock Configuration ----------------------------------
//    <h> HSE(4~25M)
//      <q0>    ʹ
//                <i> Ĭ = DISABLE
//    </h>
//    <h> HSI(48M)
//      <q1>    ʹ
//                <i> Ĭ = ENABLE
//    </h>
//
//    <h> PLL
//      <q2>    ʹ
//                <i> Ĭ  = DISABLE
//    </h>
//    <h> ϵͳʱ(SYSCLK)
//      <o3>    ϵͳʱԴ
//                <0=> HSI
//                <1=> HSE
//                <2=> PLL
//                <i> ĬϵͳʱԴ = HSI
//      <o4>  AHBƵ
//                <0=> 0
//                <1=> 2
//                <2=> 3
//                <3=> 4
//                <4=> 5
//                <5=> 6
//                <6=> 7
//                <7=> 8
//                <8=> 9
//                <9=> 10
//                <10=> 11
//                <11=> 12
//                <12=> 13
//                <13=> 14
//                <14=> 15
//                <15=> 16
//                <16=> 17
//                <17=> 18
//                <18=> 19
//                <19=> 20
//                <20=> 21
//                <21=> 22
//                <22=> 23
//                <23=> 24
//                <24=> 25
//                <25=> 26
//                <26=> 27
//                <27=> 28
//                <28=> 29
//                <29=> 30
//                <30=> 31
//                <31=> 32
//                <i> ĬϷƵ = 1
//      <o5>    APBƵ
//                <0=> 0
//                <1=> 2
//                <2=> 3
//                <3=> 4
//                <4=> 5
//                <5=> 6
//                <6=> 7
//                <7=> 8
//                <8=> 9
//                <9=> 10
//                <10=> 11
//                <11=> 12
//                <12=> 13
//                <13=> 14
//                <14=> 15
//                <15=> 16
//                <16=> 17
//                <17=> 18
//                <18=> 19
//                <19=> 20
//                <20=> 21
//                <21=> 22
//                <22=> 23
//                <23=> 24
//                <24=> 25
//                <25=> 26
//                <26=> 27
//                <27=> 28
//                <28=> 29
//                <29=> 30
//                <30=> 31
//                <31=> 32
//                <i> ĬϷƵ= 1
//    </h>
//
//
//    <h>  MCO
//      <e6>    MCOʹ
//                <i> Ĭ = DISABLE 
//        <o7>   MCOʱ
//                <0=> HSIʱ
//                <1=> HSEʱ
//                <2=> PLLʱ
//                <3=> LSIʱ
//                <4=> ϵͳʱ
//        <o8>    MCO
//                <0=> PC4
//        <o9>   MCOƵ
//                <0=> 1
//                <1=> 2
//                <2=> 4
//                <3=> 8
//                <4=> 16
//    </e>
//    </h>
//
//    <o10>ǰHSEƵ
//    <i>Default: 25000000 (Unit:Hz)
//    <0-25000000>
*/


/** @defgroup CLK_Private_Defines
  * @{
  */

#define EOSC_HSE_ENABLE	(0)     /*!< 0: DISABLE,    1: ENABLE                                     */
#define IOSC_HSI_ENABLE	(1)     /*!< 0: DISABLE,    1: ENABLE                                     */
#define IOSC_PLL_ENABLE	(0)     /*!< 0: DISABLE,    1: ENABLE                                     */
#define SystemClockSEL  (0)     /*!< 0: HSI,        1: HSE,     2: PLL,                           */
#define AHB_Prescaler	  (0)    /*!< 0: DIV1,       1: DIV1,    2: DIV1,    ......      31: DIV1  */ 
#define APB_Prescaler	  (0)     /*!< 0: DIV1,       1: DIV1,    2: DIV1,    ......      31: DIV1  */ 
#define MCO_ENABLE	    (0)     /*!< 0: DISABLE,    1: ENABLE                                     */
#define MCO_SourceSEL   (4)     /*!< 0: HSI,        1: HSE,     2: PLL,     3: LSI,     4: SYSCLK */
#define MCO_PINSEL	    (0)     /*!< 0: PC4                                                       */
#define MCO_prescale	  (0)     /*!< 0: DIV1,       1: DIV2,    2: DIV4,    3: DIV8,    4: DIV16  */
#define CrystalOscillator_Freq (25000000)

/**
  * @}
  */


/** @defgroup CLK_Private_Functions
  * @{
  */


/**
* @brief ʱԴ
* @param IOSC_HSI_ENABLE    ָ,ƬRC8Mʱʹܿ
* @param EOSC_CLK_ENABLE	ָ,ⲿƵʱʹܿ
* @param EOSC_LSI_ENABLE	ָ,ⲿƵʱʹܿ
* @retval None
*/
void CLOCK_Cmd(void)
{
    #if (EOSC_HSE_ENABLE == 1)
        GPIO_DigitalRemapConfig(AFIOA,GPIO_Pin_1,AFIO_AF_0,ENABLE);
        GPIO_DigitalRemapConfig(AFIOA,GPIO_Pin_2,AFIO_AF_0,ENABLE);  
				RCC_ClockSourceConfig(RCC_ClockSource_HSE, ENABLE);	
        while(!(RCC_GetFlagStatus(RCC_FLAG_RDY)));
	#else
				RCC_ClockSourceConfig(RCC_ClockSource_HSE, DISABLE);			
	#endif
    
    #if (IOSC_HSI_ENABLE == 1)
        RCC_ClockSourceConfig(RCC_ClockSource_HSI, ENABLE);		
	#else
				RCC_ClockSourceConfig(RCC_ClockSource_HSI, DISABLE);	
	#endif
       
    #if (IOSC_PLL_ENABLE == 1)
        #if (EOSC_HSE_ENABLE == 0)
        #error "PLLʱӿʧܣEOSC_HSE δʹ"
        #else
        RCC_ClockSourceConfig(RCC_ClockSource_PLL, ENABLE);		
        #endif		
	#else
				RCC_ClockSourceConfig(RCC_ClockSource_PLL, DISABLE);		
	#endif
}

/**
* @brief ϵͳʱ
* @param HCLK_SRC		ָ,
*     @arg 0: ʱԴѡڲRC32K
*     @arg 1: ʱԴѡⲿʱ
*     @arg 2: ʱԴѡڲPLLƵʱ
*     @arg 3: ʱԴѡڲƵʱ
* @param HCLK_DIV		ָ,HCLKķƵϵ
* @param PCLK_DIV		ָ,PCLKķƵϵ
* @retval None
*/
void CLOCK_SystemClockConfig(void)
{
    #if (SystemClockSEL == 0 )
		#if (IOSC_HSI_ENABLE == 0)
			#error "ϵͳʱԴIOSC_HSIδʹ"
		#else
			RCC_SetSystemClock(RCC_SystemClock_HSI);
		#endif
	#endif
    
    #if (SystemClockSEL == 1 )
		#if (EOSC_HSE_ENABLE == 0)
			#error "ϵͳʱԴEOSC_HSEδʹ"
		#else
      Wait_ClockReady();
			RCC_SetSystemClock(RCC_SystemClock_HSE);
      if (IOSC_HSI_ENABLE == 0)	RCC_ClockSourceConfig(RCC_ClockSource_HSI, DISABLE);
		#endif
	#endif
    
    #if (SystemClockSEL == 2 )
		#if (IOSC_PLL_ENABLE == 0)
			#error "ϵͳʱԴIOSC_PLLδʹ"
		#else
			#if (IOSC_HSE_ENABLE == 1024)
					#error "ϵͳʱԴEOSC_HSEδʹ"
			#endif
			Wait_ClockReady();
			RCC_SetSystemClock(RCC_SystemClock_PLL);
			if (IOSC_HSI_ENABLE == 0)	RCC_ClockSourceConfig(RCC_ClockSource_HSI, DISABLE);
		#endif
	#endif
    
  RCC_HCLKSetPrescaler(AHB_Prescaler);	//HCLKƵѡ
	RCC_PCLKSetPrescaler(APB_Prescaler);	//PCLKƵѡ
	
	if((RCC_GetSystemClockSelection())!= SystemClockSEL)	//ϵͳʱѡ
	{
		while(1);
	}
	RCC_SetSystemClockAfterWakeUp(RCC_SystemClockAfterWakeUp_PreviousClock);
}

/**
* @brief ϵͳʱ
* @param MCO_ENABLE	ָ,ϵͳʱʹ
* @param MCO_PINSEL		ָ,
*     @arg 0: ϵͳʱPA8
*     @arg 1: ϵͳʱPD1
* @param MCO_DIV		ϵͳʱķƵ
* @retval None
*/
void CLOCK_MCOConfig(void)
{   
    #if (MCO_ENABLE == 1)
		#if (MCO_SourceSEL == 0 )
			#if (IOSC_HSI_ENABLE == 0)
				#error "ϵͳʱԴIOSC_36M δʹ"
			#else
				RCC_SetMCOSource(RCC_ClockOutput_HSI);
			#endif
		#endif
		
		#if (MCO_SourceSEL == 1 )
			#if (EOSC_HSE_ENABLE == 0)
				#error "ϵͳʱԴEOSC_CLK δʹ"
			#else
				RCC_SetMCOSource(RCC_ClockOutput_HSE);
			#endif
		#endif
		
		#if (MCO_SourceSEL == 2 )
			#if (IOSC_PLL_ENABLE == 0)
				#error "ϵͳʱԴPLL_CLK δʹ"
			#else
				RCC_SetMCOSource(RCC_ClockOutput_PLL);
			#endif
		#endif
		
		#if (MCO_SourceSEL == 3 )
			RCC_ClockSourceConfig(RCC_ClockSource_LSI, ENABLE);
			RCC_SetMCOSource(RCC_ClockOutput_LSI);
		#endif
		
		#if (MCO_SourceSEL == 4 )
			RCC_SetMCOSource(RCC_ClockOutput_SYS);
		#endif
		
		#if (MCO_PINSEL == 0)
			GPIO_DigitalRemapConfig(AFIOC,GPIO_Pin_4,AFIO_AF_0,ENABLE);
		#endif
			RCC_MCOSetPrescaler(MCO_prescale);
    #endif
}
/**
* @brief ȡϵͳʱ
* @param none
* @retval None
*/
u32 CLOCK_GetSYSCLK(void)
{
	u32 SystemCoreClock;
	switch(SystemClockSEL)
	{
		case 0:
			SystemCoreClock=RCC_Freq_HSI;
			break;
			
		case 1:
			SystemCoreClock=CrystalOscillator_Freq;
			break;
						
		case 2:
			SystemCoreClock=CrystalOscillator_Freq*2;
			break;
			
		default:
			break;
	}
	return SystemCoreClock;
}

/**
* @brief ϵͳʱӳʼ
* @param none
* @retval None
*/
extern  void Retrim(void);
void SystemInit (void)
{
	Retrim();
	/* ʱʹ */
	CLOCK_Cmd();
	/* ϵͳʱѡ */
	CLOCK_SystemClockConfig();
	/* ϵͳʱ */
	CLOCK_MCOConfig();
}

//<<< end of configuration section >>>

/**
  * @}
  */


/**
  * @}
  */


/**
  * @}
  */


/******************* (C) Ȩ Pai-IC Microelectronics *****END OF FILE****/

