  /******************************************************************************
  * @Example ADC_Interrupt
  * @author  ӦÿŶ
  * @version V1.6.0
  * @date    2023/12/18
  * @brief   ADCתжϣжϴӡ"Trigger ADC interrupt !"־λ1־λΪ1ӡ˴תֵ
  *          
  ******************************************************************************
  * @attention	Ϊ96001λֹͣλżУ
  *							
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  *****************************************************************************/
	
#include "PT32Y003x.h"

void Software_Delay(void)//ʱ
{
	u8 i, j,x;
	for(i=0; i<200; i++)
		for(j=0; j<200; j++)
			for(x=0; x<20; x++);
}

/*******************************************************************************
*Function:	UART_GPIO_Config
*Description:	UART
*Input:		
*Return:		
*Others:
			úʹUARTģ
*******************************************************************************/
void UART_GPIO_Config(void)
{
	/* UARTܽŵĸù */
	GPIO_DigitalRemapConfig(AFIOD, GPIO_Pin_5, AFIO_AF_0,ENABLE);	//PD5 TX0
	GPIO_DigitalRemapConfig(AFIOD, GPIO_Pin_6, AFIO_AF_0,ENABLE);	//PD6 RX0
}

/*******************************************************************************
*Function:	UART_Mode_Config
*Description:	UART
*Input:		
*Return:		
*Others:
			úʼUARTģĹ乤ʽ
*******************************************************************************/
void UART_Mode_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;

	/*ʼUART0*/
	UART_InitStruct.UART_BaudRate = 9600;
	UART_InitStruct.UART_WordLengthAndParity=UART_WordLengthAndParity_8D;
	UART_InitStruct.UART_StopBitLength=UART_StopBitLength_1;
	UART_InitStruct.UART_ParityMode=UART_ParityMode_Odd;
	UART_InitStruct.UART_Receiver=UART_Receiver_Enable;
	UART_InitStruct.UART_LoopbackMode=UART_LoopbackMode_Disable;
	UART_Init(UART0, &UART_InitStruct);

	/*UART0շ*/
	UART_Cmd(UART0, ENABLE);
}

/*******************************************************************************
*Function:	UART_Driver
*Description:	UARTģ
*Input:		
*Return:		
*Others:
*******************************************************************************/
void UART_Driver(void)
{
	UART_GPIO_Config();
	UART_Mode_Config();
}

/*******************************************************************************
*Function:	ADC_GPIO_Config
*Description:	ADC
*Input:		
*Return:		
*Others:
			úʹADCģ
*******************************************************************************/
void ADC_GPIO_Config(void)
{
	GPIO_AnalogRemapConfig(AFIOC, GPIO_Pin_4, ENABLE);		//PC4ΪADCͨ
}

/*******************************************************************************
*Function:	ADC_Mode_Config
*Description:	ADC
*Input:		
*Return:		
*Others:
			úʼADCģĹ乤ʽ
*******************************************************************************/
void ADC_Mode_Config(void)
{
	ADC_InitTypeDef  ADC_InitStruct;
  NVIC_InitTypeDef NVIC_InitStruct;
	ADC_StructInit(&ADC_InitStruct);
	ADC_InitStruct.ADC_Prescaler = 48;						 
	ADC_InitStruct.ADC_Mode = ADC_Mode_Single;						//תģʽ
	ADC_InitStruct.ADC_TriggerSource = ADC_TriggerSource_Software;
	ADC_InitStruct.ADC_TimerTriggerSource=ADC_TimerTriggerSource_TIM1ADC;						//ʱԴѡTIM0¼
	ADC_InitStruct.ADC_Align = ADC_Align_Right;					//Ҷ
	ADC_InitStruct.ADC_Channel=ADC_Channel_7;						//ͨ7,PC4
	ADC_InitStruct.ADC_ReferencePositive= ADC_ReferencePositive_VDD;	//ѡVDDAΪ˲οƽ
	ADC_InitStruct.ADC_BGVoltage=ADC_BGVoltage_BG1v2;
	ADC_Init(ADC, &ADC_InitStruct);
    	
	/*ʹADCNVIC*/
  NVIC_InitStruct.NVIC_IRQChannel = ADC_IRQn;
	NVIC_InitStruct.NVIC_IRQChannelCmd = ENABLE;
	NVIC_InitStruct.NVIC_IRQChannelPriority = 0x00;
	NVIC_Init(&NVIC_InitStruct);
	
	ADC_ITConfig(ADC,ADC_IT_EOC,ENABLE);
}

/*******************************************************************************
*Function:	ADC_Driver
*Description:	ADCģ
*Input:		
*Return:		
*Others:
*******************************************************************************/
void ADC_Driver(void)
{	
	ADC_GPIO_Config();
	ADC_Mode_Config();
}

s16 Tx_Index = 0;
u8 Conversion_flag = 0;
int main (void)
{
	UART_Driver();
	ADC_Driver();
	ADC_Cmd(ADC, ENABLE);		//ADC蹦
	while(!ADC_GetFlagStatus(ADC, ADC_FLAG_RDY));	//ȴADC
	while(1)
	{		
		ADC_StartOfConversion(ADC);	//ת
		//תɴжϣתADCжϷPT32Y003_it.cļ		
		while(!Conversion_flag);
		Conversion_flag = 0;
		Tx_Index>>=1;//Ҷ봦
		printf("ADC Value:%d\r\n",Tx_Index);
    Software_Delay();
	}
}


#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif


