/******************************************************************************
  * @Example SPI
  * @author  ӦÿŶ
  * @version V1.6.0
  * @date    2023/12/18
  * @brief   ȶ԰wq25оƬеһζȡд룻дݣڶζ
  *          
  ******************************************************************************
  * @attention	
  *	ʹø:
  * ڲ96008λλ1λֹͣλУλ
	* ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣 
  * ̼/ͻʹаıϢκ,
  * Pai-ICκֱӣ ӻ̷𺦸
  * 
  * (C) ȨPai-IC Microelectronics  
  ******************************************************************************
  *****************************************************************************/	

#include "PT32Y003x.h"
#include "spi_flash.h"

void Software_Delay(void)//ʱ
{
	u8 i, j,x;
	for(i=0; i<200; i++)
		for(j=0; j<200; j++)
			for(x=0; x<20; x++);
}

/*******************************************************************************
*Function:	UART_GPIO_Config
*Description:	UART
*Input:		
*Return:		

*Others:
			úʹUARTģ
*******************************************************************************/
void UART_GPIO_Config(void)
{
	/* UARTܽŵĸù */
	GPIO_DigitalRemapConfig(AFIOD, GPIO_Pin_5, AFIO_AF_0,ENABLE);	//PD5 TX0
	GPIO_DigitalRemapConfig(AFIOD, GPIO_Pin_6, AFIO_AF_0,ENABLE);	//PD6 RX0
}

/*******************************************************************************
*Function:	UART_Mode_Config
*Description:	UART
*Input:		
*Return:		
*Others:
			úʼUARTģĹ乤ʽ
*******************************************************************************/
void UART_Mode_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;

	/*ʼUART0*/
	UART_InitStruct.UART_BaudRate = 9600;
	UART_InitStruct.UART_WordLengthAndParity=UART_WordLengthAndParity_8D;
	UART_InitStruct.UART_StopBitLength=UART_StopBitLength_1;
	UART_InitStruct.UART_ParityMode=UART_ParityMode_Odd;
	UART_InitStruct.UART_Receiver=UART_Receiver_Enable;
	UART_InitStruct.UART_LoopbackMode=UART_LoopbackMode_Disable;
	UART_Init(UART0, &UART_InitStruct);

	/*UART0շ*/
	UART_Cmd(UART0, ENABLE);
}


/*
ʼSPIܽ
*/

void SPI_GPIO_Config(void)
{
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_3, AFIO_AF_1,ENABLE);	//SPI_CSֹܸ
	GPIO_DigitalRemapConfig(AFIOC, GPIO_Pin_5, AFIO_AF_1,ENABLE);	//SPI_SCKֹܸ
	GPIO_DigitalRemapConfig(AFIOC, GPIO_Pin_6, AFIO_AF_1,ENABLE);	//SPI_MOSIֹܸ
	GPIO_DigitalRemapConfig(AFIOC, GPIO_Pin_7, AFIO_AF_1,ENABLE);	//SPI_MISOֹܸ
}

void FLASH_Init(SPI_TypeDef* SPIx)
{
  SPI_InitTypeDef SPI_InitStruct;
	/*--------------- Reset SPI init structure parameters values -----------------*/
	/* Initialize the SPI_Mode member */
	SPI_InitStruct.SPI_MasterSlaveMode = SPI_MasterSlaveMode_Master;
	/* Initialize the SPI_DataSize member */
	SPI_InitStruct.SPI_DataFrameFormat = SPI_DataFrameFormat_8b;
	/* Initialize the SPI_CPOL member */
	SPI_InitStruct.SPI_ClockPolarity = SPI_ClockPolarity_Low;
	/* Initialize the SPI_CPHA member */
	SPI_InitStruct.SPI_ClockPhase = SPI_ClockPhase_1Edge;
	/* Initialize the SPI_CSS member */
	SPI_InitStruct.SPI_CSS = SPI_CSS_SoftwareControl;
  /* Initialize the SPI_SWCS member */
	SPI_InitStruct.SPI_SoftwareControlCSS = SPI_SoftwareControlCSS_High;
	/* Initialize the SPI_Prescaler member */
	SPI_InitStruct.SPI_Prescaler = 2;
	/* Initialize the SPI_BaudRatePrescaler member */
	SPI_InitStruct.SPI_BaudRate = 20;

	SPI_Init(SPI0,&SPI_InitStruct);
	SPI_Cmd(SPI0,ENABLE);
}

uint8_t FLASH_SendByte(SPI_TypeDef* SPIx,uint8_t byte)
{
	u16 SPITimeout;
	SPITimeout = SPIT_FLAG_TIMEOUT;
  /* ȴͻΪգTXE¼ */
	while((SPI0->SR1&SPI_SR1_TXE)==0)
	{
    if((SPITimeout--) == 0)   
		{
			FLASH_ERROR("SPI ȴʱ!errorCode = %d",0);
		}
  }
  /* дݼĴҪдд뷢ͻ */
  SPI_SendData(SPIx , byte);

	SPITimeout = SPIT_FLAG_TIMEOUT;
  /* ȴջǿգRXNE¼ */
	while((SPI0->SR1&SPI_SR1_RXNE)==0)
	{
    if((SPITimeout--) == 0)   
		{
			FLASH_ERROR("SPI ȴʱ!errorCode = %d",1);
		}
   }
  /* ȡݼĴȡջ */
  return SPI_ReceiveData(SPIx );
}

uint32_t FLASH_ReadID(SPI_TypeDef* SPIx)
{
  uint32_t Temp = 0, Temp0 = 0, Temp1 = 0, Temp2 = 0;
  /* ʼͨѶCS͵ƽ */   
	SPI_SoftwareControlCSSConfig(SPIx,SPI_SoftwareControlCSS_Low);
  /* JEDECָȡID */
  FLASH_SendByte(SPIx,W25X_JedecDeviceID);
  /* ȡһֽ */
  Temp0 = FLASH_SendByte(SPIx,0x00);
  /* ȡһֽ */
  Temp1 = FLASH_SendByte(SPIx,0x00);
  /* ȡһֽ */
  Temp2 = FLASH_SendByte(SPIx,0x00);
 /* ֹͣͨѶCSߵƽ */
  SPI_SoftwareControlCSSConfig(SPIx,SPI_SoftwareControlCSS_High);

  /*Ϊķֵ*/
	Temp = (Temp0 << 16) | (Temp1 << 8) | Temp2;
  return Temp;
}

void Flash_ReadByte(SPI_TypeDef* SPIx,u32 addr)
{
	u8 data[10]={0},i;
	/* ʼͨѶCS͵ƽ */   
	SPI_SoftwareControlCSSConfig(SPIx,SPI_SoftwareControlCSS_Low);
  /* ָȡ */
  FLASH_SendByte(SPIx,W25X_ReadData);
  FLASH_SendByte(SPIx,(addr&0xFF0000)>>16);
  FLASH_SendByte(SPIx,(addr&0xFF00)>>8);
  FLASH_SendByte(SPIx,addr&0xFF);
	for(i=0;i<10;i++)
	{
  	data[i]=FLASH_SendByte(SPIx,Dummy_Byte);
	}
	printf("address: 0x%X\r\n",(unsigned int)addr);
	for(i=0;i<10;i++)
	{
  	printf("read data%d:%d\r\n",i,data[i]);
		while(!UART_GetFlagStatus(UART0,UART_FLAG_TXE));
	}
  SPI_SoftwareControlCSSConfig(SPIx,SPI_SoftwareControlCSS_High);
}
void Flash_SectorErase(SPI_TypeDef* SPIx,u32 addr)
{
	//ִдʹ
	SPI_FLASH_WriteEnable(SPI0);
  //
	SPI_SoftwareControlCSSConfig(SPIx,SPI_SoftwareControlCSS_Low);
  FLASH_SendByte(SPIx,W25X_SectorErase);
  FLASH_SendByte(SPIx,(addr&0xFF0000)>>16);
  FLASH_SendByte(SPIx,(addr&0xFF00)>>8);
  FLASH_SendByte(SPIx,addr&0xFF);
	SPI_SoftwareControlCSSConfig(SPIx,SPI_SoftwareControlCSS_High);
	SPI_FLASH_WaitForWriteEnd(SPI0);
}
void Flash_WriteByte(SPI_TypeDef* SPIx,u32 addr)
{
	u8 i,data[10]={0};
	//ִдʹ
	SPI_FLASH_WriteEnable(SPI0);
	//д
	SPI_SoftwareControlCSSConfig(SPIx,SPI_SoftwareControlCSS_Low);
  FLASH_SendByte(SPIx,W25X_PageProgram);
  FLASH_SendByte(SPIx,(addr&0xFF0000)>>16);
  FLASH_SendByte(SPIx,(addr&0xFF00)>>8);
  FLASH_SendByte(SPIx,addr&0xFF);
	for(i=0;i<10;i++)
	{
		data[i]=i*i;
	  FLASH_SendByte(SPIx,data[i]);	
	}
  SPI_SoftwareControlCSSConfig(SPIx,SPI_SoftwareControlCSS_High);
	SPI_FLASH_WaitForWriteEnd(SPI0);
}

void FLASH_ReadWrite(SPI_TypeDef* SPIx,u32 addr)
{
	Flash_SectorErase(SPI0,addr);
	Flash_ReadByte(SPI0,addr);
	Flash_WriteByte(SPI0,addr);
	Flash_ReadByte(SPI0,addr);
}

int main (void)
{
	uint32_t DeviceID;
	UART_GPIO_Config();
	UART_Mode_Config();
	printf("ڶȡflashϢ\r\n");
	SPI_GPIO_Config();
	FLASH_Init(SPI0);
	Software_Delay();
	DeviceID= FLASH_ReadID(SPI0);
	printf("Device ID:%X\r\n",DeviceID);
	FLASH_ReadWrite(SPI0,0x000);
	while(1);
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif
